//
//  ReduceVIew.m
//  TouchWave
//
//  Created by 栗子 on 2017/7/4.
//  Copyright © 2017年 wangdan. All rights reserved.
//

#import "ReduceVIew.h"

#define MaxRadius     1500
#define MaxRepeatCnt  1000

#define AddedCntPerSec      60
#define AddedRadiusPerSec   250
@interface ReduceVIew ()

@property (nonatomic,strong) UIView *view1;

@property (nonatomic,strong) UILabel *startPointLB;
@property (nonatomic,assign) NSInteger repeatCnt;
@property (nonatomic,assign) CGPoint touchPoint;
@property (nonatomic,assign) CGFloat currentRadius;
@property (nonatomic,strong) NSTimer *timer;
@property (nonatomic,strong) CADisplayLink *link;
@property (nonatomic,strong) NSTimer *time;

@end

@implementation ReduceVIew

-(instancetype)initWithReduceVIewSelfFrame:(CGRect )frame controlFrame:(CGRect )controlFrame controlColr:(UIColor *)color{
    self=[super init];
    if (self) {

        self.frame=frame;
        UIView *view=[[UIView alloc]initWithFrame:controlFrame];
        view.backgroundColor=color;
        [self addSubview:view];
        view.userInteractionEnabled=YES;
        self.view1=view;
        _touchPoint =view.center;
       
        _repeatCnt = 0;
        _currentRadius = MaxRadius;
        self.link = [CADisplayLink displayLinkWithTarget:self selector:@selector(timeSelect)];
        self.link.frameInterval=0.05;
        [self.link addToRunLoop:[NSRunLoop currentRunLoop] forMode:NSDefaultRunLoopMode];

    }
    return self;

}




-(void)drawRect:(CGRect)rect
{
    
    UIColor *drawColor =self.RControlsColor;
    [drawColor setStroke];
    CGRect newFrame = CGRectMake(_touchPoint.x-_currentRadius/2, _touchPoint.y-_currentRadius/2, _currentRadius, _currentRadius);
    UIBezierPath *bPath = [UIBezierPath bezierPathWithRoundedRect:newFrame cornerRadius:_currentRadius];
    [self.RControlsColor setFill];
    [bPath fill];
    [bPath closePath];
    [bPath setLineWidth:1];
    [bPath stroke];
    
}



-(void)timeSelect
{
    
        _currentRadius -= 16.f*AddedRadiusPerSec/AddedCntPerSec;
        if (_currentRadius<=150) {
            [self.link invalidate];
            self.link=nil;
            [self removeFromSuperview];

    }
   
    
    [self setNeedsDisplay];
    
}


@end
